'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _default = require('./adapters/default');

var _default2 = _interopRequireDefault(_default);

var _slugify = require('./slugify');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Rosetta = function () {
  function Rosetta() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$adapter = _ref.adapter,
        adapter = _ref$adapter === undefined ? new _default2.default() : _ref$adapter;

    (0, _classCallCheck3.default)(this, Rosetta);

    this._culture = null;
    this._currency = null;
    this._languages = null;

    this.translator = adapter;
  }

  (0, _createClass3.default)(Rosetta, [{
    key: 't',


    // Translate.
    value: function t(key, values) {
      return this.translator.translate(key, values);
    }

    // Format number.

  }, {
    key: 'n',
    value: function n(number) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (typeof number !== 'number') {
        throw new Error('i18n.n should receive a number.');
      }

      return typeof Intl !== 'undefined' ? new Intl.NumberFormat(this._culture, options).format(number) : number;
    }

    // Format currency number.

  }, {
    key: 'c',
    value: function c(number) {
      var minimumFractionDigits = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      return this.n(number, {
        style: 'currency',
        currency: this._currency,
        minimumFractionDigits: minimumFractionDigits
      });
    }
  }, {
    key: 'url',
    value: function url(urlPattern) {
      var _this = this;

      return urlPattern.split('/').map(function (token) {
        return (0, _slugify.slugify)(_this.t(token));
      }).join('/');
    }
  }, {
    key: 'adapter',
    set: function set(adapter) {
      this.translator = adapter;
    },
    get: function get() {
      return this.translator;
    }
  }, {
    key: 'culture',
    set: function set(culture) {
      this._culture = culture;
      this.translator.locale = culture.split('-')[0];
      this.translator.translations = this._languages[culture];
    },
    get: function get() {
      return this._culture;
    }
  }, {
    key: 'currency',
    set: function set(currency) {
      this._currency = currency;
    },
    get: function get() {
      return this._currency;
    }
  }, {
    key: 'locale',
    get: function get() {
      return this.translator.locale;
    }
  }, {
    key: 'languages',
    set: function set(languages) {
      this._languages = languages;
    }
  }]);
  return Rosetta;
}();

exports.default = Rosetta;